
#include <opencv2/opencv.hpp>

#include "infer.hpp"
#include "resnet.hpp"

using namespace std;


resnet::Image cvimg(const cv::Mat &image) { return resnet::Image(image.data, image.cols, image.rows); }



void single_inference() {
  cv::Mat image = cv::imread("inference/car.jpg");
  auto resnet = resnet::load("resnet.engine");
  if (resnet == nullptr) return;
  trt::Timer timer;
  for (int i = 0; i < 100; i++)
  {
    timer.start();
    auto attr = resnet->forward(cvimg(image));
    printf("score : %lf, label : %d\n", attr.confidence, attr.class_label);
    timer.stop("BATCH1");
  }
}

int main() {
  // [BATCH1]: 0.48650 ms
  single_inference();
  return 0;
}